﻿package classes {
	import flash.display.*;
	import flash.events.*;
	import flash.net.*;
	import flash.xml.*;
	
	public class Dialogue extends Sprite {
        
		public var dialogues = new Object();
		public var xmlData:XML = new XML();
		public var stateCounter = 0;
		public var firstState:String = "";
		
		public function Dialogue() {
		}
		
		
		public function loadFile(file:String):void {
		
		var xmlLoader:URLLoader = new URLLoader();
		
		xmlLoader.addEventListener(Event.COMPLETE, createXMLData);
		
		xmlLoader.load(new URLRequest(file));
		
		}
		////////////////
		
		private function createXMLData(e:Event):void
		{
		xmlData = new XML(e.target.data);		
		
		createDialogue(xmlData);
		}
		
		public function createDialogue(xmlData)
		{
		
		//name unnamed states
		baptizeChildren(xmlData.children());
		
		//flatten xml data
		parseStates(xmlData.children());
		
		dispatchEvent(new Event(Event.COMPLETE));
		}
		
		private function baptizeChildren(node:XMLList):void
		{
		var nodeChildren:XMLList  = node.children();
 
		for each (var child:XML in nodeChildren) {
			
			//name un named states
			if(child.attribute("id") == undefined)
				child.@id = "state_"+stateCounter;
			
			stateCounter++;
			baptizeChildren(child.children());
			}
		}
		///////
		
		private function parseStates(section:XMLList):void
		{
		
		var states:XMLList  = section.children();
 		
		for each (var state:XML in states) {
		
			var stateObj = new Object();
			stateObj.txt = state.attribute("txt").toString();
			
			//if there's data save it
			if(state.attribute("data").toString()!="")
				stateObj.data = state.attribute("data").toString();	
			
			if(firstState=="")
				firstState = state.attribute("id").toString();
			
			
				
			var choices:XMLList  = state.children();
			
			//state has a coded link -> override children and follow-up states and go to
			if(state.attribute("link") != undefined)
				{
				stateObj.link = state.attribute("link").toString();
				}
			else if(state.children().length()==0)
				{
				if(state.parent().children()[ state.childIndex() + 1 ].name() == "state")
					{
					//state followed by another state -> no choices -> link to the next state
					stateObj.link = state.parent().children()[ state.childIndex() + 1 ].attribute("id").toString();
					}
				//leaf state with no choices and no follow-up states -> END
				else
					stateObj.link = "END";
				}
			else
				{
				stateObj.choices = new Array();
				for each (var choice:XML in choices)
					{
					var choiceObj = new Object();
					choiceObj.txt = choice.attribute("txt").toString();
					
					
					
					//choice has children -> link to the first state
					if(choice.child("state")[0] != undefined)
						choiceObj.link = choice.child("state")[0].attribute("id").toString();
					//choice has no children but a link attribute -> goto
					else if(choice.attribute("link") != undefined)
						choiceObj.link = choice.attribute("link").toString();
					//choice has no links or children -> END
					else if(choice.child("choice")[0] != undefined)
						{
						throw new Error("Error in XML dialogue: a choice cannot link to another choice - state "+choice.attribute("txt").toString());
						choiceObj.link = "END";
						}
					else
						choiceObj.link = "END";
						
					stateObj.choices.push(choiceObj);
					}
					
			parseStates(state.children());
			}
			
			dialogues[state.attribute("id")] = stateObj;
			}//end state cycle
		
		
		}
		
	}
	
}