package {
	//classes you need to import to make it work!
	import classes.Dialogue;
	import classes.DialogueBox;
	import classes.DialogueEvent;
	
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.text.*;

	[SWF(width="800", height="600", backgroundColor="#000000", frameRate="30")]



	public class dialogueExample extends Sprite
	{
	/*
	For testing purposes it's more convenient to use an external xml file
	since it can be modified with an xml editor
	but when you publish the final game you might want to have a self contained 
	file so you may copy the xml source here as xml data
	*/
	
	private var xmlData:XML = 
	<main>
  <section>
    <state txt="Hello, I'm a dialogue engine Hello, I'm a dialogue engine Hello, I'm a dialogue engine Hello, I'm a dialogue engine Hello, I'm a dialogue engine Hello, I'm a dialogue engine Hello, I'm a dialogue engine yeah"/>
    <state txt="follow up state" data="some random information"/>
    <state txt="another follow up state">
      <choice txt="how do you work?"/>
      <choice txt="What?">
        <state txt="another state">
          <choice txt="really"/>
          <choice txt="fuck"/>
        </state>
      </choice>
      <choice txt="Wow cool!"/>
    </state>
  </section>
  <section>
    <state txt="how many">
      <choice txt="one">
        <state txt="good">
          <choice txt="yes"/>
          <choice txt="sure"/>
        </state>
      </choice>
      <choice txt="two"/>
      <choice txt="three"/>
      <choice txt="four"/>
    </state>
  </section>
</main>;

		
		public function dialogueExample():void
		{
			
		//step 1: create a dialogue	
		var conversation:Dialogue = new Dialogue();
		
		//step 2: since this is not instantaneous you have to use a listener
		conversation.addEventListener(Event.COMPLETE, dialogueLoaded);
		
		//step 3a: assign an external file to load
		//conversation.loadFile("test.xml");
		
		//step 3b: alternate loading use the variable xmlData
		conversation.createDialogue(xmlData);
		}
		
		public function dialogueLoaded(e:Event):void
		{
		//...ok at this point the xml data is ready to be visualized
		printDialogue(e.target);
		}
		
		
		public function printDialogue(data:Object):void
		{
		/*
		the Dialogue class converts a xml file into an actionscript data structure
		while the presentation of the dialogue is managed by the class DialogueBox
		*/
		
		//step 4: create a dialogue box instance
		//the argument for the constructor is the data sent by Dialogue.loadFile OR Dialogue.createDialogue
		var dBox:DialogueBox = new DialogueBox(data);
		
		//step 5: customize the dialogue box
		
		/* some examples: */
		
		/* TEXT ADVENTURE */
		
		
		var myFormat:TextFormat = new TextFormat();
		myFormat.color = 0x00FF00; 
		myFormat.font = "_sans";
		myFormat.size = 18;
		
		dBox.statementTextFormat = myFormat;
		dBox.choiceTextFormat = myFormat;
		
		var style:StyleSheet = new StyleSheet();
		style.setStyle("h4", h4);
		dBox.styleSheet = style;
		
		var myFormat2:TextFormat = new TextFormat();
		myFormat2.color = 0x000000; 
		myFormat2.font = "_sans";
		myFormat2.size = 18;
		myFormat2.blockIndent = 10;
		dBox.currentChoiceTextFormat = myFormat2;
		
		dBox.alternate = false;
		
		
		dBox.statementBoxFill = 0x000000;
		dBox.choiceBoxFill = 0x000000;
		dBox.currentChoiceBoxFill = 0x00FF00;
		dBox.statementBoxLineThickness = 0;
		dBox.choiceBoxLineThickness = 0;
		dBox.currentChoiceBoxLineThickness = 0;
		dBox.statementBoxWidth = 790;
		dBox.choiceBoxWidth = 790;
		
		dBox.choiceBoxMargin = 10;
		dBox.statementBoxMargin = 10;
		
		dBox.choiceBoxPadding = 0;
		dBox.statementBoxPadding = 0;
		
		dBox.typeDelay = 40;
		dBox.controls = "KEYBOARD";
		
		
		
		/* MOUSE QUIZ */
		
		/*
		
		*/
		
		
		/* DATING SIM */
		
		/*
		
		*/

		
		//step 6: add the instance
		addChild(dBox);
		//DialogueBox inherits all the Sprite properties so it can be moved using x y etc...
		
		//step 7: run the dialogue box starting from the beginning or from a specific node
		dBox.run();
		
		//step 8: you may want to know when the dialogue is over, this is the listener
		stage.addEventListener(DialogueEvent.END, endConversation);
		
		/*
		step 9: sometimes something in the game needs to be changed during the dialogue
		or as a result of certain choices: the mood of the character of visual novel
		an item given by an NPC only if the answer is correct etc...
		
		The event DialogueEvent.DATA is dispatched every time a state node contains
		a "data" attribute. DialogueEvent.data is a string copied from the xml that 
		can command certain behaviors
		*/ 
		stage.addEventListener(DialogueEvent.DATA, readData);
		}
		
		
		public function readData(e:DialogueEvent):void
		{
		trace("the conversation is sending this string: "+e.data);
		}
		
		
		public function endConversation(e:DialogueEvent):void
		{
		trace("conversation ended");
		}

	}
}
