﻿package {
	//classes you need to import to make it work!
	import classes.Dialogue;
	import classes.DialogueBox;
	import classes.DialogueEvent;
	
	import flash.display.Sprite;
	import flash.events.*;
	import flash.text.*;

	import flash.display.Loader;
    import flash.net.URLRequest;
	import flash.media.Sound;
	import flash.media.SoundChannel;
	import flash.display.MovieClip;
	import flash.utils.getDefinitionByName;
	
	[SWF(width="800", height="600", backgroundColor="#000000", frameRate="30")]



	public class dialogueExample extends Sprite
	{
	//two generic containers
	public var graphicsContainer:MovieClip;
	public var dialogueContainer:MovieClip;
	
		
	/*
	For testing purposes it's more convenient to use an external xml file
	since it can be modified with an xml editor
	but when you publish the final game you might want to have a self contained 
	file so you may copy the xml source here as xml data
	*/
	
	private var xmlData:XML = 
	<main>
  <section>
    <state txt="Hello, I'm a dialogue engine Hello, I'm a dialogue engine Hello, I'm a dialogue engine Hello, I'm a dialogue engine Hello, I'm a dialogue engine Hello, I'm a dialogue engine Hello, I'm a dialogue engine yeah"/>
    <state txt="follow up state" data="some random information"/>
  </section>
</main>;

		
		
		public function dialogueExample():void
		{
		//I create a 2 layer structure since I want the dialog
		//appear above the images
		graphicsContainer = new MovieClip();
		dialogueContainer = new MovieClip();
		
		addChild(graphicsContainer);
		addChild(dialogueContainer);
		
		
		//step 1: create a dialogue	
		var conversation:Dialogue = new Dialogue();
		
		//step 2: since this is not instantaneous you have to use a listener
		conversation.addEventListener(Event.COMPLETE, dialogueLoaded);
		
		//step 3a: assign an external file to load
		conversation.loadFile("intro.xml");
		
		//step 3b: alternate loading use the variable xmlData
		//conversation.createDialogue(xmlData);
		}
		
		public function dialogueLoaded(e:Event):void
		{
		//...ok at this point the xml data is ready to be visualized
		printDialogue(e.target);
		}
		
		
		public function printDialogue(data:Object):void
		{
		/*
		the Dialogue class converts a xml file into an actionscript data structure
		while the presentation of the dialogue is managed by the class DialogueBox
		*/
		
		//step 4: create a dialogue box instance
		//the argument for the constructor is the data sent by Dialogue.loadFile OR Dialogue.createDialogue
		var dBox:DialogueBox = new DialogueBox(data);
		
		
		//step 5: customize the dialogue box
		
		
		//dBox.upperCase = true;
		
		/* some examples: */
		
		/* TEXT ADVENTURE */
		/*
		var myFormat:TextFormat = new TextFormat();
		myFormat.color = 0x00FF00; 
		myFormat.font = "Courier";
		myFormat.size = 18;
		
		dBox.statementTextFormat = myFormat;
		dBox.choiceTextFormat = myFormat;
		
		
		var myFormat2:TextFormat = new TextFormat();
		myFormat2.color = 0x000000; 
		myFormat2.font = "Courier";
		myFormat2.size = 18;
		dBox.currentChoiceTextFormat = myFormat2;
		
		dBox.alternate = false;
		
		dBox.choiceBoxTextOffsetY = 0; //sometimes fonts have different baseline alignment: this is an easy fix
		
		dBox.statementBoxFill = 0x000000;
		dBox.choiceBoxFill = 0x000000;
		dBox.currentChoiceBoxFill = 0x00FF00;
		dBox.statementBoxLineThickness = 0;
		dBox.choiceBoxLineThickness = 0;
		dBox.currentChoiceBoxLineThickness = 0;
		dBox.statementBoxWidth = 790;
		dBox.choiceBoxWidth = 500;
		dBox.choiceBoxMarginTop = 10;
		
		dBox.choicesMinX = 10;
		
		dBox.statementMinX = 10;
		dBox.statementMinY = 10;
		
		
		dBox.choiceBoxPadding = 0;
		dBox.statementBoxPadding = 0;
		
		dBox.typeDelay = 40;
		dBox.controls = "KEYBOARD";
		
		//end text adventure example
		*/
		
		
		
		/* DATING SIM (MOUSE CONTROL) */
		/*
		var myFormat:TextFormat = new TextFormat();
		myFormat.color = 0x1C5978; 
		myFormat.font = "Arial";
		myFormat.size = 18;
		dBox.statementTextFormat = myFormat;
		
		var myFormat2:TextFormat = new TextFormat();
		myFormat2.color = 0x561C56; 
		myFormat2.font = "Arial";
		myFormat2.size = 18;
		dBox.choiceTextFormat = myFormat2;
		
		var myFormat3:TextFormat = new TextFormat();
		myFormat3.color = 0x4B3C00; 
		myFormat3.font = "Arial";
		myFormat3.size = 18;
		
		dBox.currentChoiceTextFormat = myFormat3;
		
		dBox.alternate = true;
		
		dBox.choiceBoxTextOffsetY = 0; //sometimes fonts have different baseline alignment: this is an easy fix
		
		dBox.choiceBoxRoundedCorner = 20;
		dBox.statementBoxRoundedCorner = 20;
		
		dBox.statementBoxFill = 0x3399CC;
		dBox.choiceBoxFill = 0xFF99CC;
		dBox.currentChoiceBoxFill = 0xFFCC00;
		
		dBox.statementBoxLineThickness = 4;
		dBox.choiceBoxLineThickness = 4;
		dBox.currentChoiceBoxLineThickness = 4;
		
		dBox.choiceBoxLineColor = 0x561C56;
		dBox.currentChoiceBoxLineColor = 0x4B3C00;
		
		
		dBox.statementBoxWidth = 400;
		dBox.choiceBoxWidth = 400;
		dBox.choiceBoxMarginTop = 10;
		
		dBox.choicesMaxX = 800;
		dBox.choicesMaxY = 580;
		
		dBox.statementMinX = 10;
		dBox.statementMinY = 10;
	
		dBox.choiceBoxPadding = 10;
		dBox.statementBoxPadding = 10;
		
		dBox.typeDelay = 0;
		
		dBox.clickObject = stage;
		dBox.controls = "MOUSE";
		
		//end dating sim example
		*/

	
		//step 6: add the instance
		dialogueContainer.addChild(dBox);
		//DialogueBox inherits all the Sprite properties so it can be moved using x y etc...
		
		
		//step 7: you may want to know when the dialogue is over, this is the listener
		stage.addEventListener(DialogueEvent.END, endConversation);
		
		/*
		step 7b: sometimes something in the game needs to be happen during the dialogue
		or as a result of certain choices: show an image, play a sound, change a variables... 
		
		I set up different types of EVENTS
		that can be triggered at some point by the dialogue:
		
		img - show an external image
		ext_sound - play an external sound
		movieclip - show a movieclip in the library
		sound - play a sound in the library
		data - a string containing some information
		
		they basically work in the same way:
		
		- you add an attribute like img="assets/example.png" in the xml node
		- you add a listener DialogueEvent listener of the corrisponding type
		- you write a function that receives the attributes and makes things happen
		
		
		*/ 
		
	
		//listener for external picture
		stage.addEventListener(DialogueEvent.IMG, loadPicture);
		
		//listener for external sound
		stage.addEventListener(DialogueEvent.EXT_SOUND, loadExternalSound);
		
		//listener for MovieClip 
		//in CS4/CS5 it must be in the library with a class/linkage name
		
		//in flex/builder it must be embedded using something like 
		//[Embed(source='assets/animations.swf', symbol='Ship')]
		stage.addEventListener(DialogueEvent.MOVIECLIP, showMovieClip);
		
		//listener for sound 
		//in CS4/CS5 it must be in the library with a class/linkage name
		
		//in flex/builder it must be embedded using something like 
		//[Embed(source="assets/musicLoop.mp3")]
		stage.addEventListener(DialogueEvent.SOUND, playSound);
		
		//listener for generic variable
		stage.addEventListener(DialogueEvent.DATA, readData);
		
		//step 8: run the dialogue box starting from the beginning or from a specific node
		dBox.run();
		//usage: dBox.run("anotherDialogue");
		}
		
		
		public function readData(e:DialogueEvent):void
		{
		trace("the conversation is sending this string: "+e.data);
		}
		
		public function loadPicture(e:DialogueEvent):void
		{
		trace("Loading external picture: "+e.data);
		
		/* loading and external file can take some times
		so I use a LOADER object and an event listerner to 
		make sure I visualize the image as soon as it's available*/
		
		var imageLoader:Loader = new Loader();
     	var theURL:String = e.data.toString();
     	var imageRequest = new URLRequest(theURL);

     	imageLoader.contentLoaderInfo.addEventListener(Event.COMPLETE, showPicture);
		imageLoader.contentLoaderInfo.addEventListener(IOErrorEvent.IO_ERROR, errorHandler);
		imageLoader.load(imageRequest);
		}
		
		function errorHandler(e:IOErrorEvent):void {
   		//just an empty function
		}
		
		
		
		function showPicture(e:Event) {
		
		//quick trick to remove everything in the graphics container
		while(graphicsContainer.numChildren)
			graphicsContainer.removeChildAt(0);

		//finally add the picture
		graphicsContainer.addChild(e.target.content);
     	}
		
		
		
		public function loadExternalSound(e:DialogueEvent):void
		{
		trace("Loading external sound: "+e.data);
		
		//create a new empty sound instance
		var mySound:Sound = new Sound();
		
		//load the external file
		mySound.load(new URLRequest(e.data));
		
		//play it
		mySound.play();
		}
		
		public function showMovieClip(e:DialogueEvent):void
		{
		trace("Showing movieclip: "+e.data);
		
		//quick trick to remove everything in the graphics container
		while(graphicsContainer.numChildren)
			graphicsContainer.removeChildAt(0);

		//get the object by its class name (linkage)
		var ClassReference:Class = getDefinitionByName(e.data) as Class;
		
		//create an instance of the class
        var newGraphics = new ClassReference();
        
		//add the new graphic to the container
		graphicsContainer.addChild(newGraphics);
		}
		
		
		public function playSound(e:DialogueEvent):void
		{
		trace("Playing sound: "+e.data);
		
		//get a sound by its class name (linkage)
		var ClassReference:Class = getDefinitionByName(e.data) as Class;
		
		//create a new instance of the class
		var mySound:Sound = new ClassReference();
		
		//play the sound
		mySound.play();
		}
		
		
		
		public function endConversation(e:DialogueEvent):void
		{
		trace("conversation ended");
		}

	}
}
